unit slip;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, Grids, DBGrids, StdCtrls, ExtCtrls, Mask, Db, ADODB, ComCtrls;

type
  TFormslip = class(TForm)
    Panel1: TPanel;
    DateTimePicker1: TDateTimePicker;
    Label1: TLabel;
    PageControl1: TPageControl;
    PageControl2: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ADOConnection1: TADOConnection;
    DataSource1: TDataSource;
    Panel2: TPanel;
    Label2: TLabel;
    DBEdit1: TDBEdit;
    DBRadioGroup1: TDBRadioGroup;
    Label3: TLabel;
    DBEdit2: TDBEdit;
    DBGrid1: TDBGrid;
    Label4: TLabel;
    Label5: TLabel;
    DBText1: TDBText;
    DBText2: TDBText;
    Panel3: TPanel;
    DBNavigator1: TDBNavigator;
    Panel4: TPanel;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    Label6: TLabel;
    DBEdit3: TDBEdit;
    DBLookupComboBox1: TDBLookupComboBox;
    Label7: TLabel;
    DBEdit4: TDBEdit;
    Label8: TLabel;
    DBEdit5: TDBEdit;
    Label9: TLabel;
    DBEdit6: TDBEdit;
    Panel5: TPanel;
    DBNavigator2: TDBNavigator;
    ADOQuery1: TADOQuery;
    ADOQuery1DSDesigner: TWideStringField;
    ADOQuery1DSDesigner2: TWideStringField;
    ADOQuery1DSDesigner3: TWideStringField;
    ADOQuery1DSDesigner4: TWideStringField;
    ADOQuery1DSDesigner5: TIntegerField;
    ADOQuery1DSDesigner6: TIntegerField;
    ADOQuery2: TADOQuery;
    ADOQuery3: TADOQuery;
    ADOQuery2DSDesigner: TWideStringField;
    ADOQuery2DSDesigner2: TIntegerField;
    ADOQuery2DSDesigner3: TWideStringField;
    ADOQuery2DSDesigner4: TWideStringField;
    ADOQuery2DSDesigner5: TIntegerField;
    ADOQuery2DSDesigner6: TIntegerField;
    ADOQuery2Field: TStringField;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure DateTimePicker1Change(Sender: TObject);
    procedure ADOQuery1BeforeInsert(DataSet: TDataSet);
    procedure ADOQuery1NewRecord(DataSet: TDataSet);
    procedure ADOQuery2BeforeInsert(DataSet: TDataSet);
    procedure ADOQuery2NewRecord(DataSet: TDataSet);
    procedure ADOQuery2AfterPost(DataSet: TDataSet);
    procedure DBEdit5Exit(Sender: TObject);
    procedure DBEdit6Exit(Sender: TObject);
    procedure DBEdit6Enter(Sender: TObject);
    procedure DBEdit5Enter(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    seq:integer;
    da:string;
  end;

var
  Formslip: TFormslip;
  procedure crslip;

implementation

{$R *.DFM}
procedure crslip;
begin
   Application.CreateForm(TFormslip, Formslip);
end;

procedure TFormslip.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   action:=cafree;
end;

procedure TFormslip.FormCreate(Sender: TObject);
begin
   adoconnection1.Connected:=false;
   adoconnection1.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;'+
      'Data Source='+getcurrentdir+'\|p`b޲zt.mdb;'+
      'Persist Security Info=False';
   adoconnection1.Connected:=true;
   DateTimePicker1Change(nil);
end;

procedure TFormslip.DateTimePicker1Change(Sender: TObject);
var aa,bb,cc:word;
begin
   decodedate(DateTimePicker1.date,aa,bb,cc);
   da:=formatfloat('0000',aa)+formatfloat('00',bb)+formatfloat('00',cc);
   adoquery2.Active:=false;
   ADOquery1.Active:=false;
   ADOquery1.SQL.Strings[2]:='where ǲs like '+quotedstr(da+'%');
   adoquery1.Active:=true;
   adoquery2.Active:=true;
end;

procedure TFormslip.ADOQuery1BeforeInsert(DataSet: TDataSet);
begin
   dataset.Last;
   if dataset.Bof then
      seq:=1
   else
      seq:=strtoint(copy(dataset.fieldbyname('ǲs').asstring,9,3))+1;
end;

procedure TFormslip.ADOQuery1NewRecord(DataSet: TDataSet);
begin
   dataset.FieldByName('ǲs').asstring:=da+formatfloat('000',seq);
end;

procedure TFormslip.ADOQuery2BeforeInsert(DataSet: TDataSet);
begin
   dataset.Last;
   if dataset.Bof then
      seq:=1
   else
      seq:=dataset.fieldbyname('').asinteger+1;
end;

procedure TFormslip.ADOQuery2NewRecord(DataSet: TDataSet);
begin
   dataset.fieldbyname('').asinteger:=seq;
   dataset.FieldByName('Kn').asstring:=adoquery1.fieldbyname('Kn').asstring;
end;

procedure TFormslip.ADOQuery2AfterPost(DataSet: TDataSet);
var db,cr:real;
begin
   adoquery2.First;
   db:=0;
   cr:=0;
   while not adoquery2.eof do
   begin
      db:=db+adoquery2.fieldbyname('ɤB').asfloat;
      cr:=cr+adoquery2.fieldbyname('UB').asfloat;
      adoquery2.Next;
   end;
   if not (adoquery1.State in [dsedit,dsinsert]) then
      adoquery1.Edit;
   adoquery1.FieldByName('ɤB').asfloat:=db;
   adoquery1.FieldByName('UB').asfloat:=cr;
   adoquery1.post;
   DBNavigator1.Controls[0].Enabled:=adoquery1.FieldByName('ɤB').asfloat=adoquery1.FieldByName('UB').asfloat;
   DBNavigator1.Controls[1].Enabled:=adoquery1.FieldByName('ɤB').asfloat=adoquery1.FieldByName('UB').asfloat;
   DBNavigator1.Controls[2].Enabled:=adoquery1.FieldByName('ɤB').asfloat=adoquery1.FieldByName('UB').asfloat;
   DBNavigator1.Controls[3].Enabled:=adoquery1.FieldByName('ɤB').asfloat=adoquery1.FieldByName('UB').asfloat;
end;

procedure TFormslip.DBEdit5Exit(Sender: TObject);
begin
   if adoquery2.fieldbyname('ɤB').asfloat>0 then
   begin
      if not (adoquery2.State in [dsedit,dsinsert]) then
         adoquery2.Edit;
      adoquery2.fieldbyname('UB').asfloat:=0;
   end;
end;

procedure TFormslip.DBEdit6Exit(Sender: TObject);
begin
   if adoquery2.fieldbyname('UB').asfloat>0 then
   begin
      if not (adoquery2.State in [dsedit,dsinsert]) then
         adoquery2.Edit;
      adoquery2.fieldbyname('ɤB').asfloat:=0;
   end;   
end;

procedure TFormslip.DBEdit6Enter(Sender: TObject);
begin
   if adoquery2.fieldbyname('ɤB').asfloat>0 then
      dbedit5.setfocus;
end;

procedure TFormslip.DBEdit5Enter(Sender: TObject);
begin
   if adoquery2.fieldbyname('UB').asfloat>0 then
      dbedit6.setfocus;
end;

procedure TFormslip.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   canclose:=adoquery1.FieldByName('ɤB').asfloat=adoquery1.FieldByName('UB').asfloat;
end;

end.
